package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.GP_PricingMarcaDAO;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingMarca;
import com.rjconsultores.ventaboletos.entidad.Marca;

@Repository("gp_pricingMarcaDAO")
public class GP_PricingMarcaHibernateDAO extends GenericHibernateDAO<GP_PricingMarca, Integer>
        implements GP_PricingMarcaDAO {

    @Autowired
    public GP_PricingMarcaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<GP_PricingMarca> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, GP_Pricing.ATIVO));

        return c.list();
    }

    public Boolean obtenerPricingMarca(GP_Pricing pricing, Marca marca) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, GP_Pricing.ATIVO));
        c.add(Restrictions.eq("pricing", pricing));
        c.add(Restrictions.eq("marca", marca));

        if (c.list().size() > 0) {
            return true;
        } else {
            return false;
        }
    }

	@Override
	public List<GP_PricingMarca> obtenerTodoPorPricing(GP_Pricing pricing) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("pricing.pricingId", pricing.getPricingId()));

		return c.list();
	}
}
